//-----------------------------------------------------------------------------
// Init
//-----------------------------------------------------------------------------

var Child = require('child_process');
var path   = require('path');
const vm = require('vm');


//-----------------------------------------------------------------------------
// Main
//-----------------------------------------------------------------------------


sandbox = function(code, whiteListedLibraries, defaultContext, callback ){
////////////// PREP ARGS FOR VM //////////////////////
  self = this
  timeoutValue = 5000 //millisecond timemout on all sandbox ops
  var sandboxOutput = {}
  var sandboxLogs = []
  var sandboxError
  // var code

  //TODO: this needs to be wireline logic not sandbox module logic
  var isAsyncAPI = code.indexOf("Request") + code.indexOf("done()");
  console.log('isAsyncAPI', isAsyncAPI);
  //check if we need to use the async api
  //TODO: clean this logic for detecting asyc
  if (isAsyncAPI != -2) {
    apiPath = path.join(__dirname, 'asyncvm.js')
  }else{
    apiPath = path.join(__dirname, 'vm.js')
  }


  //JSON gets serialized for child process, and deserialized on vm.js
  whiteListedLibraries = JSON.stringify ( whiteListedLibraries)
  if (!defaultContext ) {
    defaultContext = {}
  }
  defaultContext = JSON.stringify ( defaultContext);
  defaultContext.isAsyncAPI = isAsyncAPI;

/////////// SET UP TIMEOUT ////////////////////
  var timeoutID = setTimeout(function () {
    console.log('timeout kill', child.kill('SIGHUP') );
  }, timeoutValue );

////////////////// FORK OF NODE PROCESS IN CHILD PROCESS ////////////////


  // child-process.fork does not have a callback option like 'exec' which would be useful
  try {
    // silent=true disables direct logging to parent process. We actually want to listen and create logs.
    var child = Child.fork( apiPath, [code, whiteListedLibraries, defaultContext], {silent: true} );
  }
  catch(e){
    console.log('Error initiating child process', e);
  }

//GET LOGS FROM CHILD
/// util for creating the console logs array
  var processLogs = function(stdout) {
    sandboxLogs.push(stdout)
  // console.log( result )
  };
// the behavior on Node 0.10 is diffetent than current node version 6 doc. Must set output to silent
//https://nodejs.org/docs/v0.10.0/api/child_process.html#child_process_child_stdout
  child.stdout.on('data', function(data) {
    console.log(data);
    // stdout passes a buffer. Need to return to string
    console.log('data from Child.stdout: ', data.toString() );
    processLogs( data.toString() )
  });
  console.log(sandboxLogs);

/////////////PROCESS ALL MESSAGES INCLUDING ERROR AND COMPLETE ///////////

  child.on('message', function(message) {
    // console.log('sandbox message', message);
    console.log('PARENT got message:', message);
    if ( message.status === "COMPLETE" ){
      sandboxOutput.result = message.result
    }
    if ( message.status === "ERROR" ){
      sandboxError = message
      sandboxOutput.result = message.errorName +  " : " + message.errorMessage
      console.log('output on error ', sandboxOutput);
    }
  });

////////////////// CALLBACK ON CONFIRMED EXIT SUCCESS OR FAIL //////////
  child.on('exit', function (code, signal) {
    console.log('child exit code', code);
    console.log('child exit signal', signal);

    //clear the timeout if it has not passed
    var clear = clearTimeout(timeoutID)
    console.log( 'clear timeout', clear );

    // if received kill signal
    if (signal){
      console.log('timed-out');
      sandboxError = { status: 'ERROR', errorName: "Timeout", errorMessage: "code could not complete in " + timeoutValue + "ms"}
      sandboxOutput.result = sandboxError.errorName +  " : " + sandboxError.errorMessage
    }

    //waiting for all console logs
    sandboxOutput.console = sandboxLogs
    // console.log('sandboxError', sandboxError);
    // sandboxOutput.result =

    // console.log('Child exited:', code, signal);
    if ( callback && code === 0  ){
      callback(null, sandboxOutput)
    }

    //exits with error or kill signal
    if ( callback && (code != 0 || signal) ){
      callback( sandboxOutput , null)
    }
    return "Sandbox Ran"
  });

}


//-----------------------------------------------------------------------------
// EXPORTS
//-----------------------------------------------------------------------------

module.exports = sandbox;
